CREATE OR REPLACE FUNCTION PARSE_TITLE
  (IN_TITLE VARCHAR2, IN_LOCALE VARCHAR2 DEFAULT 'en')
  RETURN VARCHAR2
AS

  IS_ARTICLE BOOLEAN;
  WORD_BREAK NUMBER;
  OUT_TITLE VARCHAR2(100);
  ARTICLE_COUNT NUMBER;

BEGIN

  WORD_BREAK := INSTR(RTRIM(IN_TITLE), ' ');

  SELECT COUNT(ARTICLE) INTO ARTICLE_COUNT
    FROM ARTICLES
    WHERE ARTICLE=UPPER(SUBSTR(IN_TITLE,1,WORD_BREAK - 1))
    AND LOCALE=IN_LOCALE;

  IF ARTICLE_COUNT = 0 THEN
    IS_ARTICLE := FALSE;
  ELSE
    IS_ARTICLE := TRUE;
  END IF;
  
  IF IS_ARTICLE AND LENGTH(IN_TITLE) > WORD_BREAK THEN
    OUT_TITLE := SUBSTR(IN_TITLE, WORD_BREAK + 1) || ', ' || SUBSTR(IN_TITLE, 1, WORD_BREAK - 1);
  ELSE
    OUT_TITLE := IN_TITLE;
  END IF;

  RETURN OUT_TITLE;

END;  
/
