CREATE PROCEDURE PROCESS_ORDER (ORDER_NUMBER NUMBER) AS

  CREDIT_EXCEPTION EXCEPTION;
  ORDER_TOTAL NUMBER;
  CUSTOMER NUMBER;
  CREDIT_LIMIT NUMBER;

BEGIN

  SELECT SUM(PRICE*QUANTITY), MAX(CUSTOMER_ID)
    INTO ORDER_TOTAL, CUSTOMER
    FROM ORDERS WHERE ORDER_ID=ORDER_NUMBER
    AND STATUS='PENDING';

  SELECT CREDIT INTO CREDIT_LIMIT
    FROM CUSTOMER_CREDITS WHERE CUSTOMER_ID=CUSTOMER;

  IF ORDER_TOTAL>CREDIT_LIMIT THEN
    RAISE CREDIT_EXCEPTION;
  END IF;

  UPDATE ORDERS SET STATUS='SHIP' 
    WHERE ORDER_ID=ORDER_NUMBER AND STATUS='PENDING';
  UPDATE CUSTOMER_CREDITS SET CREDIT=CREDIT-ORDER_TOTAL
    WHERE CUSTOMER_ID=CUSTOMER;
  COMMIT;

EXCEPTION

  WHEN CREDIT_EXCEPTION THEN

        UPDATE ORDERS SET STATUS='NO CREDIT'
        WHERE ORDER_ID=ORDER_NUMBER AND STATUS='PENDING';

        INSERT INTO EXCEPTIONS VALUES(ORDER_NUMBER, CUSTOMER,
          1, 'Order total exceeds credit.');
    
END;
/
