import java.sql.*;
import oracle.jdbc.driver.*;

public class BasicJDBC {

  public static void main(String [] vars)
  {
   Connection conn;
   int rows;
   try
   {

     DriverManager.registerDriver(new oracle.jdbc.OracleDriver());
     conn = DriverManager.getConnection(
       "jdbc:oracle:thin:@noizmaker:1521:osiris",
           "david", "bigcat");
 
   // First, we'll use a Statement
   Statement stmt = conn.createStatement();
   
   // Create a table
   String sql = "CREATE TABLE EXAMPLE" +
   			          "(COL1 VARCHAR2(30)," +
                  " COL2 VARCHAR2(30)," +
                  "NUM1 NUMBER)";
       try
       {
         rows = stmt.executeUpdate(sql);
 	       System.out.println("Create table updated: " + rows + " rows");
       }
       catch(SQLException e)
       {
         // Table already exists:
         System.out.println("OK if table already exists: " + e); 
       }

   // Insert a row 
   sql = "INSERT INTO EXAMPLE VALUES" +
          "('Apple', 'Macintosh', 1)";
   rows = stmt.executeUpdate(sql);
 	 System.out.println("Insert updated: " + rows + " rows");
   
   // Now let's use a PreparedStatement to insert a couple more
   sql = "INSERT INTO EXAMPLE VALUES" +
          "(?, ?, ?)";
   PreparedStatement ps = conn.prepareStatement(sql);
   ps.setString(1, "Orange");
   ps.setString(2, "Mandarin");
   ps.setInt(3, 2);
   rows = ps.executeUpdate();
 	 System.out.println("Insert updated: " + rows + " rows");

   // We can re-use the PreparedStatement with new values
   ps.setString(1, "Banana");
   ps.setString(2, "Cavendish");
   ps.setInt(3, 3);
   rows = ps.executeUpdate();
   
   // Close the Statement
   ps.close();
   
   // Now query the table, using Statement
   sql = "SELECT COL1, COL2, NUM1 FROM EXAMPLE";
   ResultSet rs = stmt.executeQuery(sql);

   System.out.println();
   System.out.println("EXAMPLE contains:");
   while(rs.next())
   {
     System.out.println(rs.getString(1) + ", "
                          + rs.getString(2) + ", "
                          + rs.getString(3));
   }

   // Close everything still open
   rs.close();
   stmt.close();
   conn.close();
   
   
   }
   catch (SQLException e)
   {
     System.out.println("Caught: " + e);
   }
  }
}

