// Cached RowSet example:
import java.sql.*;
import javax.sql.*;
import oracle.jdbc.rowset.*;
import java.io.*;

public class CachedExample {
  
  public static void main(String [] args)
  {
    OracleCachedRowSet rowset = new OracleCachedRowSet ();
    try
    {
      rowset.setUrl("jdbc:oracle:thin:@noizmaker:1521:osiris");
      rowset.setUsername("david");
      rowset.setPassword("bigcat");
      rowset.setCommand("SELECT COL1 FROM TEST");
      rowset.execute();

     System.out.println("Initial contents:");      
     for(int i = 0; rowset.next(); i++)
      {
         System.out.println("row " + i +": " + rowset.getInt(1));
      }
      rowset.setReadOnly(false);      
      rowset.absolute(3);
      rowset.updateInt(1,7777);
      rowset.updateRow();
    }
    catch (SQLException e)
    {
      System.out.println("Caught: " + e);
    }

    String filename = "test.ser";
    try
    {

      // Write rowset to file
      FileOutputStream outStream = new FileOutputStream(filename);
      ObjectOutputStream objOut = new ObjectOutputStream(outStream);
      objOut.writeObject(rowset);
      objOut.close();
      
      // Read rowset from file
      FileInputStream inStream = new FileInputStream(filename);
      ObjectInputStream objIn = new ObjectInputStream(inStream);
      OracleCachedRowSet newrowset = (OracleCachedRowSet) objIn.readObject();
      objIn.close();

      // Make some changes to rowset, and update database:
      newrowset.last();
      newrowset.updateInt(1,9999);
      newrowset.updateRow();
      newrowset.acceptChanges();

     // Query the database to show changes have been made:
	   DriverManager.registerDriver(new oracle.jdbc.OracleDriver());
	   Connection conn = DriverManager.getConnection(
                          /* "jdbc:oracle:oci:@osiris", */
                          "jdbc:oracle:thin:@noizmaker:1521:osiris",
                          "david", "bigcat");
     Statement stmt = conn.createStatement();
     String sql = "SELECT * FROM TEST";
     ResultSet rs = stmt.executeQuery(sql);

     System.out.println("Modified data:");     
     System.out.println("[Third row should be 7777, last row, 9999]");
     while(rs.next())
     {
       System.out.println(rs.getString(1));
     }
     rs.close();
     stmt.close();
     conn.close();     

    }
    catch(Exception e)
    {
     System.out.println("Caught: " + e);       
    }
  }
}

