import java.util.Vector;
import java.sql.*;
import javax.swing.table.AbstractTableModel;
import javax.swing.event.TableModelEvent;
import javax.sql.*;
import oracle.jdbc.rowset.*;
import java.io.*;

public class RowSetModel extends AbstractTableModel {
    int rows;
    String[]            columnNames = {};    
    OracleJDBCRowSet rowset = new OracleJDBCRowSet ();
    ResultSetMetaData   metaData;
    
    public RowSetModel()
    {
         try
         {
              rowset.setUrl("jdbc:oracle:thin:@noizmaker:1521:osiris");
              rowset.setUsername("david");
              rowset.setPassword("bigcat");
              rowset.setType(ResultSet.TYPE_SCROLL_SENSITIVE);
              rowset.setConcurrency(ResultSet.CONCUR_UPDATABLE);              
              rowset.setCommand("SELECT COL1 FROM TEST");

              MyListener rowsetListener =  new MyListener ();
              rowset.addRowSetListener (rowsetListener);              

              rowset.execute();
              metaData = rowset.getMetaData();
              int numberOfColumns =  metaData.getColumnCount();
              columnNames = new String[numberOfColumns];
              for(int column = 0; column < numberOfColumns; column++)
              {
                  columnNames[column] = metaData.getColumnLabel(column+1);
              }
              rowset.last();
              rows = rowset.getRow();
              fireTableChanged(null);
        }
        catch (SQLException e)
        {
            System.err.println("Caught: " + e);
        }
     }

    public String getColumnName(int column)
    {
        if (columnNames[column] != null) {
            return columnNames[column];
        } else {
            return "";
        }
    }

    public Class getColumnClass(int column)
    {
            return String.class;
    }

    public boolean isCellEditable(int row, int column)
    {
        try {
            return metaData.isWritable(column+1);
        }
        catch (SQLException e) {
            return false;
        }
    }

    public int getColumnCount()
    {
        return columnNames.length;
    }

    public int getRowCount() {
        return rows;
    }

    public Object getValueAt(int aRow, int aColumn)
    {
      String s = null;
      try
      {
        rowset.absolute(aRow+1);
        s = rowset.getString(aColumn+1);
        System.out.println("retrieved: " + s);
      }
      catch (SQLException e)
      {
        System.out.println("Get failed: " + e);
      }
      return s;
    }

    public void setValueAt(Object value, int row, int column)
    {
        try
        {
         rowset.absolute(row+1);
         rowset.updateString(column + 1, (String) value);
         rowset.updateRow();
        }
        catch (SQLException e)
        {
            System.err.println("Update failed: " + e);
        }
    }

  class MyListener implements RowSetListener {
  
    public void cursorMoved(RowSetEvent event)
    {
    }
    public void rowChanged(RowSetEvent event)
    {
    }

    public void rowSetChanged(RowSetEvent event)
    {
         fireTableDataChanged();
    }

  }
    
}

  
