import java.sql.*;

public class UpdateExample {
   
public static void main(String [] args)
{
   try
   {   
      DriverManager.registerDriver(new oracle.jdbc.OracleDriver());
	    Connection conn = DriverManager.getConnection(
                          "jdbc:oracle:thin:@noizmaker:1521:osiris",
                          "david", "bigcat");

      Statement stmt = conn.createStatement(
                            ResultSet.TYPE_SCROLL_INSENSITIVE,
                            ResultSet.CONCUR_UPDATABLE);
      try
      {
        stmt.executeUpdate("DROP TABLE UPDATE_TEST");
      }
      catch(SQLException e)
      {
      }
      stmt.executeUpdate("CREATE TABLE UPDATE_TEST(COL1 VARCHAR2(25))");
      stmt.executeUpdate("INSERT INTO UPDATE_TEST VALUES('Hello')");
      ResultSet rs = stmt.executeQuery("SELECT COL1 FROM UPDATE_TEST");

      if(rs.next())
      {
        System.out.print("Original contents:");
        System.out.println(rs.getString(1));
      }

      // Change hello to goodbye      
      rs.updateString(1, "Goodbye");
      rs.updateRow();

      System.out.print("Changed to:");
      rs.first();
      System.out.println(rs.getString(1));

      // Insert a new row      
      rs.moveToInsertRow();
      rs.updateString(1, "This is a test");
      rs.insertRow();
      
      // We can print it out while we're here:
      System.out.println("Inserted row: " + rs.getString(1));

      // Return to where we were before
      rs.moveToCurrentRow();
      System.out.println("Current row is still: " + rs.getString(1));

      // Try to move to next row--maybe it's the inserted record?
      rs.next();
      try{
            System.out.println("Next row is: " + rs.getString(1));
      }
      catch (SQLException e)
      {
        // Oops. can't get there from here!
        System.out.println("New record isn't visible in ResultSet yet:");
        System.out.println("  " + e);
      }
   }
   catch(SQLException e)
   {
     System.out.println("Caught: " + e);
   }
}
}
      
