CREATE TYPE ELEMENT_TYPE AS OBJECT (
   ATOMIC_NUMBER NUMBER, --  can't name a column NUMBER
   SYMBOL VARCHAR2(2),
   NAME   VARCHAR2(20),
   MASS   NUMBER
);
/

CREATE TABLE PERIODIC_TABLE (
  PERIOD         NUMBER,
  COLUMN_GROUP   NUMBER,  -- can't name a column GROUP
  ELEMENT ELEMENT_TYPE
);

CREATE TABLE ELEMENTS (ELEMENT ELEMENT_TYPE);

INSERT INTO PERIODIC_TABLE
  VALUES (1,1, ELEMENT_TYPE(1, 'H', 'Hydrogen', 1.008));

INSERT INTO PERIODIC_TABLE
  VALUES (1,8, ELEMENT_TYPE(2, 'He', 'Helium', 4.003));

INSERT INTO PERIODIC_TABLE
  VALUES (2,1, ELEMENT_TYPE(3, 'Li', 'Lithium', 6.941));

COMMIT;
