-- Re-populate ARTISTS, CD_COLLECTION, SONGS;

-- Start fresh
DELETE FROM SONGS;
DELETE FROM CD_COLLECTION;
DELETE FROM ARTISTS;

-- Insert artists
INSERT INTO ARTISTS (ARTIST_ID, NAME, SURNAME, IS_GROUP, LOCALE) VALUES (22, 'Jian',            'Cui',      'F', 'zh');
INSERT INTO ARTISTS (ARTIST_ID, NAME, SURNAME, IS_GROUP, LOCALE) VALUES (29, 'Laurie',          'Anderson', 'F', 'en');
INSERT INTO ARTISTS (ARTIST_ID, NAME, SURNAME, IS_GROUP, LOCALE) VALUES (24, 'A Perfect Circle', NULL,      'T', 'en');
INSERT INTO ARTISTS (ARTIST_ID, NAME, SURNAME, IS_GROUP, LOCALE) VALUES (25, 'Pearl Jam',        NULL,      'T', 'es');
INSERT INTO ARTISTS (ARTIST_ID, NAME, SURNAME, IS_GROUP, LOCALE) VALUES (27, 'Richard and Linda Thompson',NULL, 'T' , 'en');

-- Update CD_COLLECTION table to use ARTIST_ID
ALTER TABLE CD_COLLECTION DROP COLUMN ARTIST;
ALTER TABLE CD_COLLECTION DROP COLUMN COUNTRY;
ALTER TABLE CD_COLLECTION ADD(ARTIST_ID NUMBER REFERENCES ARTISTS(ARTIST_ID));

-- Insert CDs
INSERT INTO CD_COLLECTION (CD_ID, ALBUM_TITLE, RELEASE_DATE, LABEL, ARTIST_ID)VALUES(100, 'Mer de Noms',            '1-JAN-2000', 'Virgin',        24);
INSERT INTO CD_COLLECTION (CD_ID, ALBUM_TITLE, RELEASE_DATE, LABEL, ARTIST_ID)VALUES(101, 'Big Science',            '1-JAN-1982', 'Warner',        29);
INSERT INTO CD_COLLECTION (CD_ID, ALBUM_TITLE, RELEASE_DATE, LABEL, ARTIST_ID)VALUES(102, 'Mister Heartbreak',      '1-JAN-1984', 'Warner',        29);
INSERT INTO CD_COLLECTION (CD_ID, ALBUM_TITLE, RELEASE_DATE, LABEL, ARTIST_ID)VALUES(103, 'Nothing to My Name',     '1-JAN-1989', 'EMI Hong Kong', 22);
INSERT INTO CD_COLLECTION (CD_ID, ALBUM_TITLE, RELEASE_DATE, LABEL, ARTIST_ID)VALUES(104, 'Power of the Powerless', '1-JAN-1999', 'World Beat',    22);
INSERT INTO CD_COLLECTION (CD_ID, ALBUM_TITLE, RELEASE_DATE, LABEL, ARTIST_ID)VALUES(105, 'Ten',                    '1-JAN-1991', 'Epic',          25);
INSERT INTO CD_COLLECTION (CD_ID, ALBUM_TITLE, RELEASE_DATE, LABEL, ARTIST_ID)VALUES(106, 'Vitalogy',               '1-JAN-1994', 'Epic',          25);
INSERT INTO CD_COLLECTION (CD_ID, ALBUM_TITLE, RELEASE_DATE, LABEL, ARTIST_ID)VALUES(107, 'Shoot Out the Lights',   '1-JAN-1982', 'Hannibal',      27);

-- Insert some songs
INSERT INTO SONGS (SONG_ID, CD_ID, TRACK, SONG_TITLE, COMPOSER, LENGTH) VALUES (66, 107, 1, 'Don''t Renege on Our Love',      'Thompson', 255);
INSERT INTO SONGS (SONG_ID, CD_ID, TRACK, SONG_TITLE, COMPOSER, LENGTH) VALUES (67, 107, 2, 'Walking on a Wire',              'Thompson', 324);
INSERT INTO SONGS (SONG_ID, CD_ID, TRACK, SONG_TITLE, COMPOSER, LENGTH) VALUES (68, 107, 3, 'Man in Need',                    'Thompson', 212);
INSERT INTO SONGS (SONG_ID, CD_ID, TRACK, SONG_TITLE, COMPOSER, LENGTH) VALUES (69, 107, 4, 'Just the Motion',                'Thompson', 376);
INSERT INTO SONGS (SONG_ID, CD_ID, TRACK, SONG_TITLE, COMPOSER, LENGTH) VALUES (70, 107, 5, 'Shoot Out the Lights',           'Thompson', 320);
INSERT INTO SONGS (SONG_ID, CD_ID, TRACK, SONG_TITLE, COMPOSER, LENGTH) VALUES (71, 107, 6, 'Back Street Slide',              'Thompson', 269);
INSERT INTO SONGS (SONG_ID, CD_ID, TRACK, SONG_TITLE, COMPOSER, LENGTH) VALUES (72, 107, 7, 'Did She Jump or Was She Pushed', 'Thompson/Thompson', 285);
INSERT INTO SONGS (SONG_ID, CD_ID, TRACK, SONG_TITLE, COMPOSER, LENGTH) VALUES (73, 107, 8, 'Wall of Death',                  'Thompson', 222);

COMMIT;
