import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.InitialContext;
import mypackage1.Cd_collection;
import mypackage1.Cd_collectionHome;
import mypackage1.Cd_collectionPK;
import java.util.Collection;
import java.util.Iterator;
import java.lang.Long;

public class CDInfoController extends HttpController {

  private static final String CD_SELECTED  =     "CDSELECTED";
  private static final String ARTIST_NAME  = "ARTISTNAME";
  private static final String CD_BEAN  = "CDBean";  
  private static final String JSP_PAGE = "/CDInfo.jsp";
  private static final String ERROR_PAGE = "/NotFound.jsp";  

  private String artistName;
  private long cdid;
  
  public void dispatch(HttpServletRequest request,
                       HttpServletResponse response,
                       ServletContext servletContext)
   throws ServletException, IOException
  {

    Cd_collection cdBean = null;
    CDInfoModel cdinfo;
    parseCDSelected(request);
    
    // Source from sample code...
    try
    {
      Hashtable env = new Hashtable();
      env.put(Context.INITIAL_CONTEXT_FACTORY, "com.evermind.server.rmi.RMIInitialContextFactory");
      env.put(Context.SECURITY_PRINCIPAL, "admin");
      env.put(Context.SECURITY_CREDENTIALS, "adminpwd");
      env.put(Context.PROVIDER_URL, "ormi://noizmaker/CDBean");
      Context ctx = new InitialContext(env);
      Cd_collectionHome cd_collectionHome = (Cd_collectionHome)ctx.lookup("Cd_collection");
      // end source from sample code
     
      Cd_collectionPK pk = new Cd_collectionPK(cdid);
      cdBean = cd_collectionHome.findByPrimaryKey(pk);

      // fill JavaBean
      cdinfo.setAlbumTitle(cdBean.getAlbum_title());
      cdinfo.setReleaseDate(cdBean.getRelease_date());
      cdinfo.setLabel(cdBean.getLabel());
      cdinfo.setArtistID(cdBean.getArtist_id());
      cdinfo.setCDID(cdBean.getCd_id());
    }
    catch(Exception e)
    {
      System.out.println("Caught: " + e);
    }

    RequestDispatcher dispatcher=null;
    if(cd_collection!=null)
    {
      request.setAttribute(ARTIST_NAME, artistName);
 		  request.setAttribute(CD_BEAN, cdinfo);
      dispatcher = servletContext.getRequestDispatcher(JSP_PAGE);
    }
    else
    {
      dispatcher = servletContext.getRequestDispatcher(ERROR_PAGE);
    }
    dispatcher.forward(request, response);
  }
  
  void parseCDSelected(HttpServletRequest request)
  {
    Enumeration paramNames = request.getParameterNames();
   
    while(paramNames.hasMoreElements())
    {
      String paramName = (String) paramNames.nextElement();
      System.out.println("-- " + paramName);
      if(paramName.startsWith(CD_SELECTED))
      {
        StringTokenizer st= new StringTokenizer(paramName, ";=", true);
        if(st.countTokens()>=7)
        {
          if(    st.nextToken().equals(CD_SELECTED)
              && st.nextToken().equals("="))
          {
            cdid=Long.parseLong(st.nextToken().trim());
          }
          
          if(   st.nextToken().equals(";")
             && st.nextToken().equals(ARTIST_NAME)
             && st.nextToken().equals("=")
            )
          {
             artistName=st.nextToken().trim();
          }
        }
      }
    }
  }
  
}
