// package CDApp;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public abstract class HttpController {
  
  private final static String propertiesFileName = "config\\PageClasses.properties";
  private static Properties properties = null;

  public static HttpController createController(String pageName)
  {
    HttpController controller = null;
    if(properties==null)
    {
      readProperties();
    }
    if(properties!=null)
    {
      String className = properties.getProperty(pageName);
      if(className!=null)
      {
        try
        {
          controller = (HttpController) Class.forName(className).newInstance();
        }
        catch(Exception e)
        {
          System.out.println("Caught " + e);
        }
      }
    }
    return controller;
  }

  private static void readProperties()
  {
    try
    {
        properties = new Properties();
        FileInputStream is = new FileInputStream(propertiesFileName);
        properties.load(is);
    }
    catch (IOException e)
    {
      System.out.println("Caught: " + e);
    }
  }

  
  public abstract void dispatch(HttpServletRequest request,
                                HttpServletResponse response,
                                ServletContext servletContext)
  throws ServletException, IOException;

}       
