//package CDApp;
import java.sql.*;
import java.util.Vector;

public class MusicResults
{ 
  Connection connection = null;
  private Vector artist = new Vector();
  private Vector title = new Vector();
  private Vector artistId = new Vector();
  private Vector cdId = new Vector();  
  private int size = 0;
  private static final int maxResults = 25;
  
  public MusicResults()
  throws SQLException
  {
    connect();
    executeQuery(null, null);
  }

  MusicResults(String artistName, String cdTitle)
  {
    try
    {
      connect();
      executeQuery(artistName, cdTitle);
    }
    catch(SQLException e)
    {
      System.out.println("Caught: " + e);
    }
    finally
    {
      try
      {
        if(connection!=null)
        {
          connection.close();
        }
      }
      catch (SQLException e)
      {
        int i =0;// ignore error closing connection
      }
    }
  }

  private void executeQuery(String artistName, String cdTitle)
  throws SQLException  
  {
    StringBuffer sql = new StringBuffer(
                       "SELECT DISPLAY_NAME(A.NAME, A.SURNAME, A.LOCALE), " +
                       "C.ALBUM_TITLE, A.ARTIST_ID, C.CD_ID " +
                       "FROM ARTISTS A, CD_COLLECTION C " +
                       "WHERE C.ARTIST_ID = A.ARTIST_ID ");

    if(artistName!=null && !artistName.equals(""))
    {
      sql.append("AND UPPER(A.SORT_NAME) LIKE UPPER('%" + artistName + "%') ");
    }
    
    if(cdTitle!=null && !cdTitle.equals(""))
    {
      sql.append("AND UPPER(C.ALBUM_TITLE) LIKE UPPER('%" + cdTitle + "%') ");
    }
    sql.append("ORDER BY A.SORT_NAME, C.ALBUM_TITLE");
    
    Statement stmt = connection.createStatement();
    ResultSet rs = stmt.executeQuery(sql.toString());
    int i = 0;
    
    while(rs.next() && i++ < maxResults)
    {
      artist.add(rs.getString(1));
      title.add(rs.getString(2));
      artistId.add(new Integer(rs.getInt(3)));
      cdId.add(new Integer(rs.getInt(4)));
    }
    size = artist.size();
    rs.close();
    stmt.close();
  }
  
  private void connect()
  throws SQLException
  {
       DriverManager.registerDriver(
       new oracle.jdbc.OracleDriver());
       connection = DriverManager.getConnection(
               "jdbc:oracle:thin:@noizmaker:1521:osiris",
               "david", "bigcat");
  }

  public String getArtistAt(int i)
  {
    return (String) artist.elementAt(i);
  }
  
  public String getTitleAt(int i)
  {
    return (String) title.elementAt(i);
  }

  public int getArtisIdAt(int i)
  {
    return ((Integer)artistId.elementAt(i)).intValue();
  }

  public int getCdIdAt(int i)
  {
    return ((Integer)cdId.elementAt(i)).intValue();
  }
  
  public int getSize()
  {
    return size;
  }
}

