import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class MusicServlet extends HttpServlet 
{
  public final static String pageParamName = "REQUESTPAGE";
  public final static String defaultPage = "/StartPage.jsp";

  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  {
    doAction(request, response);
  }
  
  public void doPost(HttpServletRequest request, HttpServletResponse response)
  {
    doAction(request, response);
  }
  
  public void doAction(HttpServletRequest request, HttpServletResponse response)
  {
    try
    {
      String page = request.getParameter(pageParamName);
      HttpController controller;
      if(page==null 
        || (controller= HttpController.createController(page))==null)
      {
        RequestDispatcher dispatcher = 
            getServletContext().getRequestDispatcher(defaultPage);
            dispatcher.forward(request, response);
      }
      else
      {
        controller.dispatch(request, response, getServletContext());
      }
    }
    catch(Exception e)
    {
      System.out.println("Caught: " + e);
    }
  }
}
