package mypackage3;
import java.sql.*;
import java.util.*;
import javax.naming.*;
import java.io.*;

public class CDInfoDAO 
{
  Connection conn = null;
  Statement stmt = null;
  
  public CDInfoDAO()
  {
  }
  
  public CDInfoModel createCDInfoModel(long cd_id)
  {
    CDInfoModel cdModel = new CDInfoModel();
    try
    {
      getConnection();
      stmt = conn.createStatement();
      // Get CD info
      String sql = "SELECT DISPLAY_NAME(A.NAME, A.SURNAME, A.LOCALE), " +
                   "C.ALBUM_TITLE, C.LABEL, " +
                   "TO_CHAR(C.RELEASE_DATE,'YYYY') " +
                   "FROM CD_COLLECTION C, ARTISTS A " +
                   "WHERE C.ARTIST_ID = A.ARTIST_ID " +
                   "AND CD_ID = " + cd_id;
      ResultSet rs = stmt.executeQuery(sql);
      while(rs.next())
      {
        cdModel.setArtistName(rs.getString(1));
        cdModel.setTitle(rs.getString(2));
        cdModel.setLabel(rs.getString(3));
        cdModel.setReleaseDate(rs.getString(4));
      }
      rs.close();
    
      // Get song list
      Vector songs = new Vector();
      sql = "SELECT TITLE, COMPOSER, LENGTH FROM SONGS " +
            "WHERE  CD_ID=" + cd_id;
      rs = stmt.executeQuery(sql);
      while(rs.next())
      {
        CDSong song = new CDSong();
        song.setTitle(rs.getString(1));
        song.setComposer(rs.getString(2));
        song.setLength(rs.getInt(3));
        songs.add(song);
      }
      cdModel.setSongs(songs);
      rs.close();
      stmt.close();
      closeConnection();
    }
    catch (Exception e)
    {
      System.out.println("createCDinfoModel() - Caught: " + e);
    }
    return cdModel;
  }
  
  private void getConnection()
  {
    try
    {
      InitialContext ic=new InitialContext();
      javax.sql.DataSource ds=(javax.sql.DataSource)(ic.lookup("jdbc/OsirisDS"));
      System.out.println("Datasource: " + ds);
      conn= ds.getConnection();
    }
    catch(Exception e)
    {
      System.out.println("getConnection() - Caught: " + e);
    }
  }

  private void closeConnection()
  throws SQLException
  {
    conn.close();
  }
}