package example;

import javax.jdo.PersistenceManagerFactory;
import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.jdo.Extent;
import javax.jdo.Query;
import java.util.Iterator;
import java.util.Collection;

public class PersonTest 
{
  public static void main(String [] args)
  {
    // Configuration parameters
    String PMFCLASS = "com.libelis.lido.PersistenceManagerFactory";
    String DBDRIVER = "oracle.jdbc.driver.OracleDriver";
    String DBURL    = "jdbc:oracle:thin:@noizmaker:1521:osiris";
    String DBUSERNAME = "jdoexample";
    String DBPASSWORD = "jdoexample";
    
    try
    {

      // Obtain persistence manager from persistence manager factory
      PersistenceManagerFactory pmf = (PersistenceManagerFactory)
          Class.forName(PMFCLASS).newInstance();
      pmf.setConnectionDriverName(DBDRIVER);
      pmf.setConnectionURL(DBURL);
      pmf.setConnectionUserName(DBUSERNAME);
      pmf.setConnectionPassword(DBPASSWORD);

      PersistenceManager pm = pmf.getPersistenceManager();

      // Create and begin transaction
      Transaction tx = pm.currentTransaction();
      tx.begin();

      // Create and persist Person object
      Person person = new Person();
      person.setName("Bruce");
      person.setCity("Asbury Park");
      person.setContactInfo("theBoss@example.com");
      
      // pm.makePersistent(person);
      tx.commit();

      // Extent
      Extent ext = pm.getExtent(Person.class, false);
      Iterator iter = ext.iterator();
      while(iter.hasNext())
      {
        Person p = (Person) iter.next();
        System.out.println("ext:    Name: " + p.getName());
        System.out.println("ext:    City: " + p.getCity());
        System.out.println("ext: Contact: " + p.getContactInfo());        
      }
      
      // Query 
      // String filter = "name==selectedName";
      // Query q = pm.newQuery(ext, filter);
      Query q = pm.newQuery(ext);
      // q.declareParameters("String selectedName");
      q.setOrdering("city ascending, name ascending");      
      Collection result = (Collection) q.execute();

      iter = result.iterator();
      while(iter.hasNext())
      {
        Person p = (Person) iter.next();
        System.out.println("q:    Name: " + p.getName());
        System.out.println("q:    City: " + p.getCity());
        System.out.println("q: Contact: " + p.getContactInfo());        
      }
      query.close(result);
      pm.close();
    }
    catch(Exception e)
    {
      System.out.println("Caught: " + e);
    }
  }
}
    

