package example;

import javax.jdo.PersistenceManagerFactory;
import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.jdo.Extent;
import javax.jdo.Query;
import java.util.Iterator;
import java.util.Collection;
import java.util.Vector;
import java.util.Calendar;

public class PhotoTestAdd 
{
  public static void main(String [] args)
  {
    // Configuration parameters
    String PMFCLASS = "com.libelis.lido.PersistenceManagerFactory";
    String DBDRIVER = "oracle.jdbc.driver.OracleDriver";
    String DBURL    = "jdbc:oracle:thin:@noizmaker:1521:osiris";
    String DBUSERNAME = "jdoexample";
    String DBPASSWORD = "jdoexample";
    
    try
    {

      // Obtain persistence manager from persistence manager factory
      PersistenceManagerFactory pmf = (PersistenceManagerFactory)
          Class.forName(PMFCLASS).newInstance();
      pmf.setConnectionDriverName(DBDRIVER);
      pmf.setConnectionURL(DBURL);
      pmf.setConnectionUserName(DBUSERNAME);
      pmf.setConnectionPassword(DBPASSWORD);

      PersistenceManager pm = pmf.getPersistenceManager();

      // Create transaction
      Transaction tx = pm.currentTransaction();

      // Create subjects: name, city, contactInfo, position, age
      Subject rover = new Subject();
      rover.setName("Rover");
      rover.setCity("Anytown");
      rover.setContactInfo("");
      rover.setPosition("Center, front");
      rover.setAge(8);

      Subject mom = new Subject();
      mom.setName("Mom");
      mom.setCity("Anytown");
      mom.setContactInfo("mom@example.com");
      mom.setPosition("Left");
      mom.setAge(30);
      
      Subject dad = new Subject();
      dad.setName("Dad");
      dad.setCity("Anytown");
      dad.setContactInfo("dad@example.com");
      dad.setPosition("Right");
      dad.setAge(30);

      Subject jr = new Subject();
      jr.setName("Junior");
      jr.setCity("Anytown");
      jr.setContactInfo("");
      jr.setPosition("Center, back");
      jr.setAge(3);

      // photo 1
      // - includes subjects, title, description, notes
      Vector subjects1 = new Vector();
      subjects1.add(rover);
      subjects1.add(mom);
      subjects1.add(dad);
      subjects1.add(jr);      
      
      Photo photo1 = new Photo();
      photo1.setTitle("Family at park");
      photo1.setSubjects(subjects1);
      photo1.setDescription("Family standing next to picnic table");
      photo1.setNotes("No flash, auto-timer");

      // photo 2
      Vector subjects2 = new Vector();
      rover.setPosition("Left");
      jr.setPosition("Right");
      subjects2.add(rover);
      subjects2.add(jr);
      
      Photo photo2 = new Photo();
      photo2.setTitle("Junior and Rover");
      photo2.setSubjects(subjects2);
      photo2.setDescription("Junior and Rover playing ball");

      // photo 3
      Vector subjects3 = new Vector();
      mom.setPosition("Center");
      subjects3.add(mom);
      
      Photo photo3 = new Photo();
      photo3.setTitle("Mom - the diva");
      photo3.setSubjects(subjects3);
      photo3.setDescription("Mom singing that Shania Twain song");
      photo3.setNotes("Flash");
      
      Vector photoset1 = new Vector();
      photoset1.add(photo1);
      photoset1.add(photo2);
      photoset1.add(photo3);      
      
      // Create Photographer - Dad
      Photographer photog1 = new Photographer();
      photog1.setName("Dad");
      photog1.setCity("Cambridge");
      photog1.setContactInfo("dad@example.com");
      photog1.setEquipment("Sony digital camera");
      photog1.setBio("Amateur photographer");
      
      // Create Photosession 1
      PhotoSession sess1 = new PhotoSession();
      sess1.setPhotographer(photog1);
      sess1.setLocation("Lakeside Park");
      Calendar cal = Calendar.getInstance();
      cal.set(2002, 3, 23);
      sess1.setSessionDate(cal.getTime());
      sess1.setPhotos(photoset1);

      // Add session reference to photos
      photo1.setPhotoSession(sess1);
      photo2.setPhotoSession(sess1);
      photo3.setPhotoSession(sess1);      
      
      // Make Photosession 1 persistent
      tx.begin();
      pm.makePersistent(sess1);      
      tx.commit();
      
      // Photos - set 2
      Photo mt = new Photo();
      mt.setTitle("Desertscape with Rover");
      mt.setDescription("Storm cloud above mountain;" +
                         " Rover fights cactus and loses.");
      mt.setNotes("About 30 minute exposure on handmade " +
                   "photosensitive paper");
      // subject                   
      Vector mtsubjects = new Vector();
      mtsubjects.add(rover);
      mt.setSubjects(mtsubjects);

      Photo still = new Photo();
      still.setTitle("Cactus flower");
      still.setDescription("Cactus with flower and pear");
      still.setNotes("About 8 minute exposure on handmade " +
                   "photosensitive paper");

      Vector photoset2 = new Vector();
      photoset2.add(mt);
      photoset2.add(still);
                   
      // Create Photographer 2 - Mom
      Photographer photog2 = new Photographer();
      photog2.setName("Mom");
      photog2.setCity("Cambridge");
      photog2.setContactInfo("therealboss@example.com");
      photog2.setEquipment("oatmeal box pinhole camera");
      photog2.setBio("Kodak Instamatic School of Photography");
      
      // Create Photosession 2
      PhotoSession sess2 = new PhotoSession();
      sess2.setPhotographer(photog2);
      sess2.setLocation("Southern New Mexico");
      
      cal.set(2002, 4, 10);
      sess2.setSessionDate(cal.getTime());
      sess2.setPhotos(photoset2);

      // Add session reference to photos
      mt.setPhotoSession(sess2);
      still.setPhotoSession(sess2);
      
      
      // Make persistent
      tx.begin();
      pm.makePersistent(sess2);      
      tx.commit();
      
      pm.close();      
    }
    catch (Exception e)
    {
      System.out.println("Caught e: " + e);
    }
  }
}

